using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Drawing;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
   
 

namespace BindingArrayList
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private DataCollection ParentdataSource;
		private Bitmap RedExclamation  = null;
	

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			RedExclamation = new Bitmap(@"./../../SFERROR.BMP"); 

			System.Drawing.Icon ico = new System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
			this.Icon = ico ;			
			this.gridGroupingControl1.TableModel.Options.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid;
			this.gridGroupingControl1.TableModel.Properties.GridLineColor = System.Drawing.Color.Silver;	

			ParentdataSource = new DataCollection();
			ParentdataSource.Add(new Data("1", "Condiments", "Sweets", 2));
			ParentdataSource.Add(new Data("2", "Confections", "Deserts and Candies", 2));
			ParentdataSource.Add(new Data("3", "Grains/Cereals", "Breads, pasta and cereal", 2));
			ParentdataSource.Add(new Data("4", "Meat/Poultry", "Prepared meats", 2));
			ParentdataSource.Add(new Data("5", "Produce", "Dried fruit and bean curd", 2));
			ParentdataSource.Add(new Data("6", "Seafood", "Seeweed and fish", 2));

			this.gridGroupingControl1.DataSource = ParentdataSource;
			this.gridGroupingControl1.ShowGroupDropArea = true;
			
			this.gridGroupingControl1.Table.ExpandAllRecords(); 

			this.gridGroupingControl1.TableControlCurrentCellValidating +=new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellValidating);

			this.gridGroupingControl1.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

			this.gridGroupingControl1.TableControlDrawCell +=new GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell); 


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 16);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(584, 224);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.201.0.37";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 320);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(576, 160);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// button1
			// 
			this.button1.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button1.Location = new System.Drawing.Point(440, 248);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(152, 56);
			this.button1.TabIndex = 2;
			this.button1.Text = "GET VALID CHANGED VALUES";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 248);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(416, 48);
			this.label1.TabIndex = 3;
			this.label1.Text = "Enter the even number in \"OTHERIFNO\" column to store the value in a HashTable";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 494);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Custom Collection implementing IBindingList";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		Hashtable Cells = new Hashtable();
		private void gridGroupingControl1_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			if( cc.ColIndex == 4)
			{
				if( IsValid(cc) )
				{
					Cells[GetHashCode(cc.RowIndex,cc.ColIndex)] = cc.Renderer.ControlText;
					SetErrorText(sender,"OtherInfo","CurrentCell event your Text");
					e.Inner.Cancel = true; 
				}
			}
		}
		private void SetErrorText(object sender, string FiledDescriptorName,string ErrorMsg)
		{
			GridGroupingControl grid = sender as GridGroupingControl;
			foreach (CurrentRecordProperty prop in grid.Table.CurrentRecordManager.Properties)
			{
				if(prop.FieldDescriptor.Name == FiledDescriptorName )
					prop.Exception = new Exception(ErrorMsg, prop.Exception);
			}
		}


		private bool IsValid(GridCurrentCell cc)
		{
			int iValue = int.Parse(cc.Renderer.ControlText); 
			if( iValue %2 == 0 )
			{
				return true;
			}
			return false;
		}
		private string GetHashCode(int RowIndex,int ColIndex)
		{
			return "#" + RowIndex +"##" + ColIndex + "#";
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.textBox1.Text = string.Empty;
 
			for(int i = 0 ;i < this.gridGroupingControl1.TableModel.RowCount; i++)   
				if( Cells.Contains(GetHashCode(i,4)))
				{
					this.textBox1.Text += Environment.NewLine + string.Format("Cell[{0},{1}] = {2}",i,3, Cells[GetHashCode(i,4)].ToString());   
				}
			if( this.textBox1.Text == string.Empty)
			{
				this.textBox1.Text = "No valid values found...."; 
			}
			else
				this.textBox1.Text += Environment.NewLine + "Search Done....";
		}

		private void gridGroupingControl1_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
		{
			GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo;  
			if( style != null 
				&& style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record
				&& e.Inner.Style.Tag != null  
				&& style.TableCellIdentity.Column != null 
				&& style.TableCellIdentity.Column.Name == "OtherInfo" )  
			{
				e.Inner.Renderer.Draw(e.Inner.Graphics,e.Inner.Bounds,e.Inner.RowIndex,e.Inner.ColIndex,e.Inner.Style);              
				Rectangle rect =new Rectangle( new Point(e.Inner.Bounds.Right - 20,e.Inner.Bounds.Top ),new Size(20,e.Inner.Bounds.Height));  
				e.Inner.Graphics.DrawImage(RedExclamation ,(RectangleF)rect);     
			}
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record
				&& e.TableCellIdentity.Column != null 
				&& e.TableCellIdentity.Column.Name == "OtherInfo" )  
			{
				if( e.Style.Text != null && e.Style.Text != string.Empty )
				{
					int iValue = int.Parse(e.Style.Text); 
					if( iValue %2 == 0 )
					{
						e.Style.TextMargins.Right += 20;   
						e.Style.Tag = true;
						e.Style.CellTipText = "Error";
					}
				}

			}
		}
	}
}
